summaryrefslogtreecommitdiff
path: root/share
diff options
context:
space:
mode:
authorTodd Gamblin <tgamblin@llnl.gov>2016-05-11 02:01:24 -0700
committerTodd Gamblin <tgamblin@llnl.gov>2016-05-11 02:01:24 -0700
commit78d25ad337e2faaa8cfd589607801acb78aec4d9 (patch)
tree51e606ebb297c1ba28a1f4c4426074c2c596849e /share
parentc512b37a4e26bb639893d06c9f2df30fb6dd6892 (diff)
downloadspack-78d25ad337e2faaa8cfd589607801acb78aec4d9.tar.gz
spack-78d25ad337e2faaa8cfd589607801acb78aec4d9.tar.bz2
spack-78d25ad337e2faaa8cfd589607801acb78aec4d9.tar.xz
spack-78d25ad337e2faaa8cfd589607801acb78aec4d9.zip
Add run-flake8 script.
- was missing the obvious.
Diffstat (limited to 'share')
-rwxr-xr-xshare/spack/qa/run-flake855
1 files changed, 55 insertions, 0 deletions
diff --git a/share/spack/qa/run-flake8 b/share/spack/qa/run-flake8
new file mode 100755
index 0000000000..722c7fcba6
--- /dev/null
+++ b/share/spack/qa/run-flake8
@@ -0,0 +1,55 @@
+#!/bin/bash
+#
+# This script runs source code style checks on Spack.
+#
+# It should be executed from the top-level directory of the repo,
+# e.g.:
+#
+# share/spack/qa/run-flake8
+#
+# To run it, you'll need to have the Python flake8 installed locally.
+#
+PYTHONPATH=./lib/spack:$PYTHONPATH
+
+flake8="$(which flake8)"
+if [[ ! $flake8 ]]; then
+ echo "ERROR: flake8 is required to run this script."
+ exit 1
+fi
+
+# Check if changed files are flake8 conformant [framework]
+changed=$(git diff --name-only develop... | grep '.py$')
+
+# Exempt url lines in changed packages from overlong line errors.
+for file in $changed; do
+ if [[ $file = *package.py ]]; then
+ perl -i~ -pe 's/^(\s*url\s*=.*)$/\1 # NOQA: ignore=E501/' $file;
+ fi
+done
+
+return_code=0
+if [[ $changed ]]; then
+ echo =======================================================
+ echo flake8: running flake8 code checks on spack.
+ echo
+ echo Modified files:
+ echo $changed | perl -pe 's/^/ /;s/ +/\n /g'
+ echo =======================================================
+ if flake8 --format pylint $changed; then
+ echo "Flake8 checks were clean."
+ else
+ echo "Flake8 found errors."
+ return_code=1
+ fi
+else
+ echo No core framework files modified.
+fi
+
+# Restore original package files after modifying them.
+for file in $changed; do
+ if [[ $file = *package.py ]]; then
+ mv "${file}~" "${file}"
+ fi
+done
+
+exit $return_code